import cv2, os, time
from lobe import ImageModel

cap = cv2.VideoCapture(0)
cap.set(3,640) # set Width
cap.set(4,480) # set Height
green=(0,255,0)
# path = '/home/pi/Lobe'

print("Loading model...")
model = ImageModel.load('/home/pi/08_Autonomous_Systems/Lobe/model_1V1')
path = '/home/pi/Lobe'

while(True):
    start_time = time.monotonic()
    ret, frame = cap.read()
    cv2. imwrite(os. path. join(path , 'camimage.jpg'), frame)
    result = model.predict_from_file('/home/pi/Lobe/camimage.jpg')
    cv2.putText(frame,result.prediction,(30,30), cv2.FONT_HERSHEY_SIMPLEX, 1,green,2)
    cv2.imshow('press "q" to quit', frame)
    elapsed_sec = (time.monotonic() - start_time)
    fps = 1/elapsed_sec
    print(result.prediction, "fps= ", round(fps,2))
    key = cv2.waitKey(1) & 0xFF
    if key == ord("q"):
        print(key)
        break

cap.release()
cv2.destroyAllWindows()

