import cv2, os, time
from lobe import ImageModel
import RPi.GPIO as GPIO

in1=24;in2=23;enA=25 # pins motor 1
in3=17;in4=18;enB=27 # pins motor 2
GPIO.setmode(GPIO.BCM)
GPIO.setup(in1,GPIO.OUT);GPIO.setup(in2,GPIO.OUT)  # all pins as outputs
GPIO.setup(in3,GPIO.OUT);GPIO.setup(in4,GPIO.OUT)
GPIO.output(in3,GPIO.LOW);GPIO.output(in4,GPIO.LOW) # prevent unintended movement
GPIO.output(in1,GPIO.LOW);GPIO.output(in2,GPIO.LOW)
GPIO.setup(enA,GPIO.OUT);GPIO.setup(enB,GPIO.OUT) # setup PWM for motor control
p1=GPIO.PWM(enA,1000);p2=GPIO.PWM(enB,1000)  # f_PWM = 1000 Hz
p1.start(enA);p2.start(enB)
p1.ChangeDutyCycle(30);p2.ChangeDutyCycle(30)

cap = cv2.VideoCapture(0)
cap.set(3,320); cap.set(4,240) # set Width & Height of Cam image
green=(0,255,0) # print color on screen

print("Loading model...")
path = '/home/pi'
model = ImageModel.load(path+'/08_Autonomous_Systems/Lobe/model_1V1')

while(True):
    start_time = time.monotonic()
    ret, frame = cap.read()
    cv2. imwrite(os. path. join(path , 'camimage.jpg'), frame)
    result = model.predict_from_file(path+'/camimage.jpg')
    cv2.putText(frame,result.prediction,(30,30), cv2.FONT_HERSHEY_SIMPLEX, 1,green,2)
    cv2.imshow('press "q" to quit', frame)
    resultControl=result.prediction
    print(resultControl)
    
    if resultControl=='bckgrnd':
        print("forward")
        GPIO.output(in1,GPIO.HIGH);GPIO.output(in2,GPIO.LOW)
        GPIO.output(in3,GPIO.HIGH);GPIO.output(in4,GPIO.LOW)
    elif resultControl=='b':
        print("backward")
        GPIO.output(in1,GPIO.LOW);GPIO.output(in2,GPIO.HIGH)
        GPIO.output(in3,GPIO.LOW);GPIO.output(in4,GPIO.HIGH)
    elif resultControl=='GoLeft':
        print("turning left")
        GPIO.output(in1,GPIO.LOW);GPIO.output(in2,GPIO.HIGH)
        GPIO.output(in3,GPIO.HIGH);GPIO.output(in4,GPIO.LOW)
        time.sleep(1)
        GPIO.output(in1,GPIO.LOW);GPIO.output(in2,GPIO.LOW)
        GPIO.output(in3,GPIO.LOW);GPIO.output(in4,GPIO.LOW)
    elif resultControl=='GoRight':
        print("turning right")
        GPIO.output(in1,GPIO.HIGH);GPIO.output(in2,GPIO.LOW)
        GPIO.output(in3,GPIO.LOW);GPIO.output(in4,GPIO.HIGH)
        time.sleep(1)
        GPIO.output(in1,GPIO.LOW);GPIO.output(in2,GPIO.LOW)
        GPIO.output(in3,GPIO.LOW);GPIO.output(in4,GPIO.LOW)
    key = cv2.waitKey(1) & 0xFF
    if key == ord("q"):
        break
    elapsed_sec = (time.monotonic() - start_time)
    fps = 1/elapsed_sec
    print("fps= ", round(fps,2))
    
print("bye...");GPIO.cleanup();cap.release()
cv2.destroyAllWindows()