# Train_road_signs
# for Raspberry Pi contolled mBot

import tensorflow  as tf
import os,cv2,time
from tensorflow.keras.preprocessing import image
import numpy as np
from imutils import video
import RPi.GPIO as GPIO

in1=24;in2=23;enA=25 # pins motor 1
in3=17;in4=18;enB=27 # pins motor 2
GPIO.setmode(GPIO.BCM)
GPIO.setup(in1,GPIO.OUT);GPIO.setup(in2,GPIO.OUT)  # all pins as outputs
GPIO.setup(in3,GPIO.OUT);GPIO.setup(in4,GPIO.OUT)
GPIO.output(in3,GPIO.LOW);GPIO.output(in4,GPIO.LOW) # prevent unintended movement
GPIO.output(in1,GPIO.LOW);GPIO.output(in2,GPIO.LOW)
GPIO.setup(enA,GPIO.OUT);GPIO.setup(enB,GPIO.OUT) # setup PWM for motor control
p1=GPIO.PWM(enA,1000);p2=GPIO.PWM(enB,1000)  # f_PWM = 1000 Hz
p1.start(enA);p2.start(enB)
p1.ChangeDutyCycle(80);p2.ChangeDutyCycle(80)


imgSize = 32

cap = cv2.VideoCapture(0)
cap.set(3,320) # set Width
cap.set(4,320) # set Height
green=(0,255,0)
folder = "/home/pi/DATA/Road_signs/Test"

labelNames=open("signnames.csv").read().strip().split("\n")[1:]
model = tf.keras.models.load_model('road_signs_model_1_0.h5')

while(True):
    start_time = time.monotonic()
    ret,frame = cap.read()
    cv2.imwrite(os.path.join(folder,'camimage.jpg'),frame)
    
    img=os.path.join(folder,"camimage.jpg")
    img=image.load_img(img,target_size=(imgSize, imgSize))
    img=image.img_to_array(img)
    img=np.expand_dims(img,axis=0)
    
    result=model.predict(img)
    n=np.argmax(result)
    #  test n=0
    print(n)
    
    cv2.putText(frame,str(labelNames[n]),(10,20), cv2.FONT_HERSHEY_SIMPLEX, .5,green,1)
    cv2.imshow('press "q" to quit',frame)
    
    if (n!=0 and n!=1):
        print("forward")
        GPIO.output(in1,GPIO.HIGH);GPIO.output(in2,GPIO.LOW)
        GPIO.output(in3,GPIO.HIGH);GPIO.output(in4,GPIO.LOW)
    elif n==1:
        print("turning left")
        GPIO.output(in1,GPIO.LOW);GPIO.output(in2,GPIO.HIGH)
        GPIO.output(in3,GPIO.HIGH);GPIO.output(in4,GPIO.LOW)
        time.sleep(1)
        GPIO.output(in1,GPIO.LOW);GPIO.output(in2,GPIO.LOW)
        GPIO.output(in3,GPIO.LOW);GPIO.output(in4,GPIO.LOW)
    elif n==0:
        print("turning right")
        GPIO.output(in1,GPIO.HIGH);GPIO.output(in2,GPIO.LOW)
        GPIO.output(in3,GPIO.LOW);GPIO.output(in4,GPIO.HIGH)
        time.sleep(1)
        GPIO.output(in1,GPIO.LOW);GPIO.output(in2,GPIO.LOW)
        GPIO.output(in3,GPIO.LOW);GPIO.output(in4,GPIO.LOW)
    
    key = cv2.waitKey(1) & 0xFF
    if key == ord("q"):
        break
    elapsed_sec = (time.monotonic() - start_time)
    fps = 1/elapsed_sec
    print("fps= ", round(fps,2))

print("bye...");GPIO.cleanup();cap.release()
cap.release()
cv2.destroyAllWindows()
